-- script by apuehri,and  a little bit by suzi
--Converted by WeeRuz
--edit by Nola
print("mod loaded: newpda scripted by apuehri");

newpda = {};


function newpda:loadMap(name)
  self.stations = {};
  self.numstations = 0;
  self.numfruits = 0;
  self.visible = {};
  self.showprices=false;
  self.showstat=false;
  self.farmtrigger = {};
  self.farmnum = 0;
  self.stationNames = {};
  local i = 1;
  local cnt = true;
  local fruitcnt = 0;
	
	table.foreach(g_currentMission.tipTriggers,function (k)  
  --for i=1, table.maxn(g_currentMission.tipTriggers) do
  
    if k.appearsOnPDA then
	
      local s=k.stationName;
	  table.insert(self.stationNames,i,s)
      self.numstations=self.numstations+1;
      table.insert(self.stations,i,{});
      for a=1, FruitUtil.NUM_FRUITTYPES do
        self.visible[a]=self.visible[a] or false;
        local l=k.acceptedFruitTypes[a];
        if l~=nil then
          v=k.priceMultipliers[a];
          self.visible[a]=true;
        else
          v=nil;
        end;        
        self.stations[i][a]=v;
        if cnt then
          self.numfruits=self.numfruits+1;
        end;
      end;
	else
	
		if k.isFarmTrigger then
		
			for b=1, FruitUtil.NUM_FRUITTYPES do
				local c=k.acceptedFruitTypes[b];
				if c~=nil then
					if self.farmnum>=1 then
							for d=1, self.farmnum do
								if self.farmtrigger[d]~=b then
									fruitcnt=fruitcnt+1;
								end;	
							end;
						if fruitcnt==self.farmnum then
							fruitcnt=0;
							self.farmnum=self.farmnum+1;
							self.farmtrigger[self.farmnum]=b;
						else
							fruitcnt=0;
						end;	
					else
						self.farmnum=self.farmnum+1;
						self.farmtrigger[self.farmnum]=b;
					end;
				end;	
			end;
		end;	
    end;       
  --end;
 i = i + 1;
  end)

  local tmp=self.numfruits;
  for a=1, self.numfruits do
    if not self.visible[a] then
      tmp=tmp-1;
    end;
  end;
  self.numfruits=tmp; --   Hintergrund aendern
  self.HudInfoWidth=0.6/(self.numstations+2);  
 
  self.subHudBack = Utils.getFilename("$dataS2/missions/hud_env_base.png", newpda.baseDirectory);
  self.subHudInfoPoxX = 0.277; --  1.Zeichen von links nach rechts
  self.subHudInfoPoxY = 0.80; --   1.Zeichen von oben nach unten
  self.subHudBackPoxX = 0.2; -- links rechts
  self.subHudBackWidth = 0.7; -- breite
  self.subHudBackPoxY = 0.5-((0.255+(self.numfruits*0.028))/2); --hoch runter 
  self.subHudBackHeight = ((0.365+(self.numfruits*0.028))); -- hoehe oberer rand
  self.subHudInfoPoxY = 0.5+((0.305+(self.numfruits*0.028))/2)-0.055; --   nach unten verschieben 
 
  newpda.hud = Overlay:new("hud", self.subHudBack, newpda.subHudBackPoxX, newpda.subHudBackPoxY, newpda.subHudBackWidth, newpda.subHudBackHeight);

  
  newpda.hud.a = 0.5;
  self.loadedMap = name;
end;

function newpda:deleteMap()
end;

function newpda:update(dt)

	if InputBinding.hasEvent(InputBinding.TOGGLE_PDA) then 
	
		if not self.showprices and not self.showstat then		
		 
			if g_currentMission.missionPDA.showPDA and g_currentMission.missionPDA.screen==2 then  
			
				self.showprices = true;
				g_currentMission.missionPDA.showPDA = false;
			end;
		else
			if not self.showstat then
				self.showprices = false;
				g_currentMission.missionPDA.showPDA = true;
				g_currentMission.missionPDA.screen=3;
			end;
		end;
		if not self.showstat then
			if g_currentMission.missionPDA.showPDA and g_currentMission.missionPDA.screen==3 then
				self.showstat = true;
				g_currentMission.missionPDA.showPDA = true;				
			end;
		else
			self.showstat = false;
			g_currentMission.missionPDA.showPDA = true;
		end;
		
	end; 
end;

function newpda:mouseEvent(posX, posY, isDown, isUp, button)
end;

function newpda:keyEvent(unicode, sym, modifier, isDown) 
end;
function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end
function newpda:draw()

local fontsizecaption1= 0.023; --berschrift1
local fontsizecaption2= 0.020; --berschrift2
local fontsize= 0.016; --Normalschrift
local linehigh=0.035; --Zeilenhhe hoch
local line=0.026; --Zeilenhhe normal
local tabin=0.005; --Einzug
local tabin1=0.03; --GrundEinzug Stationsname+Preis
local fact=0 ; --Level/Preis Multiplikator

	if self.showprices then
	 
	
		self.hud:render();
		setTextBold(true);
		setTextColor(1,1,0,1);
		--os.setlocale("German_Austria.1252")
		renderText(self.subHudInfoPoxX, self.subHudInfoPoxY , fontsizecaption1, "Verkaufspreise:  "..os.date("%d.%b %Y,")..os.date(" %H:%M"));
		local x = 0;
		setTextBold(false);
		setTextColor(0,1,1,1);
		renderText(self.subHudInfoPoxX, self.subHudInfoPoxY-linehigh , fontsizecaption2, g_i18n:getText("PricePerTon"));
		for i=1, table.maxn(self.stations) do
			local a = self.stations[i];
			if a~=nil then        
				x=x+1;
				setTextBold(true);
				setTextColor(0,1,1,1);
				local StName = g_i18n:getText(self.stationNames[i]);
				if string.find(StName,".xml")~=nil then
					StName = self.stationNames[i];
				end;
				renderText(((self.subHudInfoPoxX+tabin1)+(x*self.HudInfoWidth)), self.subHudInfoPoxY-linehigh , fontsizecaption2, StName);
				local scr_y = 1;
				for y=1, table.maxn(a) do
					if (FruitUtil.fruitIndexToDesc[y].pricePerLiter==FruitUtil.fruitIndexToDesc[y].yesterdaysPrice) then
						setTextBold(false);
						setTextColor(1,1,1,1);
					end;
					if (FruitUtil.fruitIndexToDesc[y].pricePerLiter<FruitUtil.fruitIndexToDesc[y].yesterdaysPrice) then 
						setTextBold(false);
						setTextColor(1,0,0,1);
					end;
					if (FruitUtil.fruitIndexToDesc[y].pricePerLiter>FruitUtil.fruitIndexToDesc[y].yesterdaysPrice) then
						setTextBold(false);
						setTextColor(0,1,0,1);
					end;
					local s=g_i18n:getText(FruitUtil.fruitIndexToDesc[y].name);				
					if self.visible[y] then
						renderText(self.subHudInfoPoxX, self.subHudInfoPoxY-linehigh-(scr_y*line) , fontsize, s);
					end;	
					if self.visible[y] then
						local b=a[y];
						if (b~=nil) then
							if g_currentMission.missionStats.difficulty==1 then
								fact=6000;
							elseif g_currentMission.missionStats.difficulty==2 then
								fact=3000;
							elseif g_currentMission.missionStats.difficulty==3 then	
								fact=1000;
							end;	
							local c=round(tonumber(b)*tonumber(FruitUtil.fruitIndexToDesc[y].pricePerLiter)*fact,0);
							local p=tostring(c);
							if self.visible[y] then
								renderText(((self.subHudInfoPoxX+tabin1)+((x*self.HudInfoWidth)+tabin)), self.subHudInfoPoxY-linehigh-(scr_y*line) , fontsize, p);
							end;
						end;
						scr_y=scr_y+1;
					end;
				end;
			end;  
		end;      
  end;
	if self.showstat then
		--Allgemein
		local diesel = Utils.getNoNil(g_currentMission.missionStats.fuelUsageTotal,0); --Dieselverbrauch
		local bottles = Utils.getNoNil(g_currentMission.deliveredBottles,0); --Flaschen
		local repu = Utils.getNoNil(g_currentMission.reputation,0); --Ansehen
		local threshed = Utils.getNoNil(g_currentMission.missionStats.hectaresThreshedTotal,0) ;--gedroschene Hektar gesamt
		local threshedact = Utils.getNoNil(g_currentMission.missionStats.hectaresThreshedSession,0) ;--gedroschene Hektar akt.
		local seeded = Utils.getNoNil(g_currentMission.missionStats.hectaresSeededTotal,0) ;--geshte Hektar gesamt
		local seededact = Utils.getNoNil(g_currentMission.missionStats.hectaresSeededSession,0) ;--geshte Hektar akt.
		local money = Utils.getNoNil(g_currentMission.missionStats.money,0); --Geld
		local zeit = Utils.getNoNil(g_currentMission.missionStats.playTime/60,0); --Spielzeit
        local distance = Utils.getNoNil(g_currentMission.missionStats.traveledDistanceTotal/3,0) ; --gefahrene Kilometer
		
		
		self.hud:render();
		setTextBold(true);
		setTextColor(1,1,0,1);
		renderText(self.subHudInfoPoxX, self.subHudInfoPoxY , fontsizecaption1, "Statistik");
		setTextColor(0,1,1,1);
		renderText(self.subHudInfoPoxX, self.subHudInfoPoxY-linehigh , fontsizecaption2, "Silos:");
		setTextBold(false);
		local linenum=0 ;--Zeilennummer
		for i=1, self.farmnum do
			if self.farmtrigger[i]~=nil then
				linenum=linenum+1;
				local j=self.farmtrigger[i];
				local fruitname = g_i18n:getText(FruitUtil.fruitIndexToDesc[i].name);
				local silofruit = Utils.getNoNil(g_currentMission.missionStats.farmSiloAmounts[FruitUtil.fruitTypeToFillType[i]],0);
				--Spalte 1
				setTextBold(false);
				setTextColor(1,1,1,1);
				renderText(self.subHudInfoPoxX, self.subHudInfoPoxY-linehigh-(line*linenum), fontsize,""..string.format("%s: ", fruitname).."");
				--Spalte 2
				renderText(self.subHudInfoPoxX+(1.3*self.HudInfoWidth), self.subHudInfoPoxY-linehigh-(line*linenum), fontsize,""..string.format("%.0f ", silofruit).." t");
			end;	
		end;		
		--Spalte 3
		setTextBold(true);
		setTextColor(0,1,1,1);
		renderText(self.subHudInfoPoxX+(self.HudInfoWidth*2), self.subHudInfoPoxY-linehigh , fontsizecaption2, "Zusammenfassung:");
		setTextBold(false);
		setTextColor(1,1,1,1);
		renderText(self.subHudInfoPoxX+(self.HudInfoWidth*2), self.subHudInfoPoxY-linehigh-line, fontsize,""..string.format("Diesel verbraucht : %.0f ", diesel).."l");
		renderText(self.subHudInfoPoxX+(self.HudInfoWidth*2), self.subHudInfoPoxY-linehigh-(line*2), fontsize,""..string.format("Gefahren : %.0f ", distance).."km");
		renderText(self.subHudInfoPoxX+(self.HudInfoWidth*2), self.subHudInfoPoxY-linehigh-(line*3), fontsize,""..string.format("Total Geaerntet Total / Spiel: %.0f ", threshed).." / "..string.format(" %.0f ", threshedact).."ha");
		renderText(self.subHudInfoPoxX+(self.HudInfoWidth*2), self.subHudInfoPoxY-linehigh-(line*4), fontsize,""..string.format("Total Bepflanzt Total / Spiel: %.0f ", seeded).." / "..string.format(" %.0f ", seededact).."ha");		
		setTextBold(true);
		setTextColor(0,1,0,1);
		renderText(self.subHudInfoPoxX+(self.HudInfoWidth*2), self.subHudInfoPoxY-linehigh-(line*5), fontsizecaption2,""..string.format("Geld : %.0f ", money).."euros");
		setTextBold(false);
		setTextColor(1,1,1,1);
		renderText(self.subHudInfoPoxX+(self.HudInfoWidth*2), self.subHudInfoPoxY-linehigh-(line*6), fontsize,""..string.format("Gesammtspielzeit : %.0f ", zeit).."Std");
		renderText(self.subHudInfoPoxX+(self.HudInfoWidth*2), self.subHudInfoPoxY-linehigh-(line*7), fontsize,""..string.format("Gesammelte Flaschen : %.0f ", bottles).."Stk");
		renderText(self.subHudInfoPoxX+(self.HudInfoWidth*2), self.subHudInfoPoxY-linehigh-(line*8), fontsize,""..string.format("Reputation : %.0f ", repu).."%");

	end;
end;

function newpda:delete()
	if self.hud ~= nil then
		self.hud:delete();
	end; 
end;

addModEventListener(newpda);


